module ProgressDownload
  @@custom_spinners = Hash.new

  def self.spinner_hash
    types = %w{ classic bats tracer arrows pump breathe fold sorter dots }.map(&:to_sym)
    types.push *@@custom_spinners.keys

    flat = Array.new
    flat << %w{ - \\ | / Done! }  # Traditional line spinner
    flat << %w{ /^v^\\ \\^v^/ \\ovo/ } # Happy bats, old DOS spinner.
    flat << %w{ ⠁ ⠂ ⠄ ⡀ ⢀ ⠠ ⠐ ⠈ · } # Rectangle trace
    flat << %w{ ← ↖ ↑ ↗ → ↘ ↓ ↙ ↔ } # Arrows
    flat << %w{ ▁ ▂ ▃ ▄ ▅ ▆ ▇ █ ▇ ▆ ▅ ▄ ▃ ▁ █ } # Grow shrink
    flat << %w{ ▉ ▊ ▋ ▌ ▍ ▎ ▏ ▎ ▍ ▌ ▋ ▊ ▉ ▉ } # Thin and fat
    flat << %w{ ┤ ┘ ┴ └ ├ ┌ ┬ ┐ ✓ } # Folding lines
    flat << %w{ ⣾ ⣽ ⣻ ⢿ ⡿ ⣟ ⣯ ⣷ ⣿ } # Braille arranger
    flat << %w{ ⠖ ⠲ ⠴ ⠦ ⠶ } # Braille spinner
    flat.push *@@custom_spinners.values

    spinners = Hash.new
    types.each.with_index { |type, i| spinners[type] = flat[i] }
    spinners
  end

  SPINNERS = spinner_hash

  def self.add_spinner name, states
    @@custom_spinners[name.to_sym] = states
    SPINNERS.replace spinner_hash
  end
end
